#
# Gentool needs two "/" partitions  of equal size and two /boot 
# partitions of equal size. At any given moment, one pair will 
# be active and the other will be the backup. 
# 
# Each "/" and /boot pair can be located on a different HDD.
#
# Write device paths here. For example: "/dev/sda1"
#
# your current /boot partition device path:
boot_partition_A=""

# your current "/" partition device path:
root_partition_A=""

# the other /boot partition
boot_partition_B=""

# the other "/" partition
root_partition_B=""

#
# For each HDD with a /boot partition, gentool needs to know the
# corresponding grub disk name: hd0, hd1, hd2 or etc.
#
# If you're not sure which disk maps to what, run grub and, at the grub 
# prompt, type: geometry (hd0) and then geometry (hd1) and so on for hd2, 
# hd3 etc, depending how many disks you have. The grub geometry command 
# shows some information about partitions so you can usually work out 
# which /dev/sdx corresponds to which grub disk.
#
# Note we want *disk* names here not *partition* names.
#
grub_name_of_disk_containing_boot_partition_A=""
grub_name_of_disk_containing_boot_partition_B=""


#
# Some dirs, eg /proc and /sys, should never be copied in the OS/apps 
# backup job (gentool copy).
#
# You don't need to edit this.
#
root_excludes=(
    /dev        
    /lost+found
    /media
    /mnt        
    /proc       
    /sys        
    /tmp
    /var/tmp
)
#
# For items in the $root_excludes list, only the top-level dir is copied
# (and not the contents). If you need to automatically re-create a custom 
# directory structure in any of these dirs, add the (absolute) dir paths 
# here. Many people will want to rebuild a few dirs in /mnt. Dirs used 
# by gentool (/mnt/gentoo and /mnt/gentoo/boot) are already listed.
#
rebuild_filesystem=(
    /mnt/gentoo
    /mnt/gentoo/boot
)

#
# In the OS/apps backup job (gentool copy), any dirs named in this list will 
# *not* have any of their contents copied. This allows mount points to be 
# handled properly. 
#
# For example, if you mount a separate partition on /home, add /home to the
# list. All the contents of /home will be excluded from the OS/apps backup.
#
# Any data dirs which you do not add here (ie small items which don't merit 
# their own partition) *must* be added to copy_on_switch below or else you 
# may lose data.
#
my_mount_points=(
    #/home
    #/var/lib/mysql    
)

#
# When you do a switch you (temporarily) have two different system versions: 
# the broken newer system and the older backup. That's as it should be, so 
# you can try some repairs and eventually choose which one you want to keep.
#
# At this point we run into a problem. If any data dirs were left on the 
# "/" partition we now have two potential versions of the same data, each 
# tagging along with one of the system versions.
#
# The solution is to always copy these items to the about-to-become-active 
# root partition in a gentool switch command. The latest copy of the data 
# will alway travel with you to the newly active partitions. 
#
# All you have to do is name the items you want to copy-on-switch below. 
#
# This list overrides $root_excludes or $my_mount_points lists above. 
#
# It's a bad idea to add /etc to this list or anything potentially 
# responsible for the kind which made you want to switch in the first 
# place.
#
copy_on_switch=(
    #/root
    #/var/lib/mysql
)

#
# If you need some additional copy/switch behaviour you can 
# write custom bash scripts.
#
# The file /root/.gentool/pre-copy.sh, if it exists, will 
# automatically be run every time you run "gentool copy".
#
# The file /root/.gentool/pre-switch.sh, if it exists, will 
# automatically be run every time you run "gentool switch".
#
# If you can't think why you'd need these, you don't.
#

#
# $ module-rebuild rebuild will automatically be run after 
# building a new kernel. Add anything here which isn't 
# picked up by that, eg lirc:
#
rebuildWhenNewKernel()
{
    echo
    #emerge lirc
}

#
# path to your kernel image (edit for arch)
#
# bzpath='/usr/src/linux/arch/x86/boot/bzImage'
bzpath=''

#
# a web server of your choice to pass to htpdate -ds
# make sure they don't mind
#
# clock_uri='www.a-website-of-your-choice.com'
clock_uri=''
