showHelp()
{
    
    cat '/opt/gentool/docs/halp.txt'
}
getMode() 
{
    local irf
    local arm
    local mode

    mountAll
    
    irf=`getPartitionAttachedTo / $gentool_mirror_mount_point'/etc/fstab'`
    arm=`getPartitionAttachedTo / '/etc/mtab'`
    if [ $irf = $arm ] 
    then
        mode='mirror'
    fi

    if [ $irf = $inactive_root_partition ] 
    then
        mode='dual'
    fi
    echo $mode
    
    umountAll
    return 0 
}
#
# $1 - the active partition
# $2 & $3 - the two it might be
#
getTheOtherOne() 
{
    if [ "$1" = "$2" ] 
    then
        echo "$3"
        return 0
    fi
    if [ "$1" = "$3" ] 
    then
        echo "$2"
        return 0
    fi
    echo "ERROR in getTheOtherOne(): out of cheese"
    exit 1
}
mountAll()
{
    mount /boot
    mount $inactive_root_partition ${gentool_mirror_mount_point}'/'
    mount $inactive_boot_partition ${gentool_mirror_mount_point}'/boot/'
}
umountAll()
{
    umount /boot
    umount $inactive_boot_partition
    umount $inactive_root_partition
}
#
# The backup routine copies the active fstab to the backup. 
# If we want to boot from the backup, we need to change 
# some partition numbers.
#
editMirrorFstab()
{
    local fstab_mirror=${gentool_mirror_mount_point}'/etc/fstab'

    echo "`cat /etc/fstab | sed s,$active_boot,$inactive_boot,`" > $fstab_mirror
    echo "`cat $fstab_mirror | sed s,$active_root,$inactive_root,`" > $fstab_mirror
    echo
}
#
# ditto
#
editMirrorGrubConf()
{
    local a=$active_boot_grub_partition_number
    local m=$inactive_boot_grub_partition_number
    local inactive_grubconf=$gentool_mirror_mount_point'/boot/grub/grub.conf'
    local active_grubconf='/boot/grub/grub.conf'
    
    if [ ! -f "$active_grubconf" ]
    then
        echo "file [$active_grubconf] does not exist"
        echo 'exiting...'
        mountAll
        exit 1
    fi
    if [ ! -f $inactive_grubconf ]
    then
        echo "mirror grub.conf [$inactive_grubconf] does not exist"
        echo 'exiting...'
        umountAll
        exit 1
    fi
    echo "`cat $active_grubconf | sed "s/hd0,$a/hd0,$m/g" | sed s,$active_root,$inactive_root,g`" > $inactive_grubconf
    echo
}
#
# $1 - device path eg /dev/sda3
#
getGrubName()
{
    local name

    if [ "$boot_partition_A" = "$1" ]
    then
        name=$grub_name_of_disk_containing_boot_partition_A
    else
        name=$grub_name_of_disk_containing_boot_partition_B
    fi
    echo $name
}
getDisk()
{
    echo $1 | grep -o [/[:lower:]]* | grep -o [^/]*$
}
#
# $1 - dest dir
#
# The $copy_on_switch list is defined in /etc/gentool/config.sh
#
copyOnSwitch()
{
    local d
    local dest
    
    dest=`oneEndSlash "$1"`

    for d in ${copy_on_switch[@]}
    do 
        eval rsync ${d} ${dest} "$copy_on_switch_policy" 
    done
}
#
# needs more work?
#
gentoolSanityChecks()
{
    local num_gm_args=$1    
    local devices="$boot_partition_A $root_partition_A $boot_partition_B $root_partition_B"
    local mount_points
    local m
    local d
    local grub_name

    mount_points=`echo ${gentool_mirror_mount_point}'/ ' ${gentool_mirror_mount_point}'/boot/'`

    if [ $num_gm_args -eq 0 ]
    then
        showHelp
        exit 0
    fi
    
    #if [ ! "`echo $devices | grep [[:alnum:]]`" ]
    #then
    #        echo 'No devices ['${devices}']. You need to open /etc/gentool/config.sh and define the vars: $boot_partition_A $root_partition_A #$boot_partition_B $root_partition_B'
    #        exit 1
    #fi
    for d in $devices
    do
        if [ ! -b $d ] 
        then
            echo '['$d'] is not a valid device file: you need to edit /etc/gentool/config.sh'
            exit 1
        fi
    done
    #
    # don't do these until all device checks are OK
    #
    for d in $devices
    do
        grub_name=`getGrubName $d`
        
        if [ "" = "$grub_name" ]
        then    
            echo 'you need to define the var $grub_name_of_'`getDisk $d`' in /etc/gentool/config.sh'
            exit 1
        fi
        if [ "" = "`echo $grub_name | grep ^hd`" ]
        then
            echo 'the var [$grub_name_of_'`getDisk $d`'] defined in /etc/gentool/config.sh has value ['$grub_name'] but should be of the form hd0, hd1, hd2 etc'
            exit 1
        fi
    done
    #
    #!! other device misconfig errors appear to be possible..
    #!! - no B p's defined
    #

    for m in $mount_points
    do
        if [ ! -d $m ] 
        then
            mkdir -vp $m
        fi
    done    
}

